"""
This file was autogenerated by genproperties.py

LINSTOR - management of distributed storage/DRBD9 resources
Copyright (C) 2017 - 2020  LINBIT HA-Solutions GmbH
Author: Rene Peinthor, Gabor Hernadi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
import linstor.sharedconsts as consts
properties = \
{   u'controller': [   {   u'info': u'Range for auto-allocation of resource TCP ports',
                           u'key': consts.KEY_TCP_PORT_AUTO_RANGE,
                           u'type': u'regex',
                           u'value': u'[0-9]+-[0-9]+'},
                       {   u'info': u'Range for auto-allocation of volume minor numbers',
                           u'key': consts.KEY_MINOR_NR_AUTO_RANGE,
                           u'type': u'regex',
                           u'value': u'[0-9]+-[0-9]+'},
                       {   u'info': u'DRBD peer slots to allocate for newly created resources (default 7), the number of peer slots cannot be changed once the resource is created, so allow sufficient slots to increase redundancy in the future',
                           u'key': consts.KEY_PEER_SLOTS_NEW_RESOURCE,
                           u'max': 31,
                           u'min': 1,
                           u'type': u'range'},
                       {   u'info': u'Enable dmstats on lvm create',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_DMSTATS,
                           u'type': u'boolean_true_false'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_USER_NAME,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_USER_PW,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_URL,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_RETRY_COUNT,
                           u'type': u'regex',
                           u'value': u'[0-9]+'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_RETRY_DELAY,
                           u'type': u'regex',
                           u'value': u'[0-9]+'},
                       {   u'info': u'Globally sequentialize all ctrl -> stlt api calls',
                           u'key': consts.KEY_GLOBAL_SEQ_API_CALLS,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Bind address of the REST API',
                           u'internal': False,
                           u'key': consts.NAMESPC_REST + '/' + consts.KEY_BIND_ADDR,
                           u'type': u'string'},
                       {   u'info': u'TCP Port of the REST API',
                           u'internal': False,
                           u'key': consts.NAMESPC_REST + '/' + consts.KEY_BIND_PORT,
                           u'max': 65535,
                           u'min': 1,
                           u'type': u'range'},
                       {   u'info': u'Bool if REST API should be enabled',
                           u'internal': False,
                           u'key': consts.NAMESPC_REST + '/' + consts.KEY_ENABLED,
                           u'type': u'boolean_true_false'},
                       {   u'default': u'rdma',
                           u'internal': False,
                           u'key': consts.NAMESPC_NVME + '/' + consts.KEY_TR_TYPE,
                           u'type': u'symbol',
                           u'values': [u'rdma', u'tcp']},
                       {   u'internal': False,
                           u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PORT,
                           u'max': 65535,
                           u'min': 1,
                           u'type': u'range'},
                       {   u'info': u'Preferred network interface to use',
                           u'internal': False,
                           u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PREF_NIC,
                           u'type': u'regex',
                           u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_WAIT_TIMEOUT_AFTER_CREATE,
                           u'type': u'regex',
                           u'value': u'[0-9]+'},
                       {   u'drbd_option_name': u'read-balancing',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/read-balancing",
                           u'type': u'symbol',
                           u'values': [   u'prefer-local',
                                          u'prefer-remote',
                                          u'round-robin',
                                          u'least-pending',
                                          u'when-congested-remote',
                                          u'32K-striping',
                                          u'64K-striping',
                                          u'128K-striping',
                                          u'256K-striping',
                                          u'512K-striping',
                                          u'1M-striping']},
                       {   u'drbd_option_name': u'on-io-error',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/on-io-error",
                           u'type': u'symbol',
                           u'values': [   u'pass_on',
                                          u'call-local-io-error',
                                          u'detach']},
                       {   u'default': True,
                           u'drbd_option_name': u'disk-drain',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-drain",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'resync-after',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/resync-after",
                           u'type': u'string'},
                       {   u'default': 0,
                           u'drbd_option_name': u'disk-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-timeout",
                           u'max': 6000,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': False,
                           u'drbd_option_name': u'disable-write-same',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disable-write-same",
                           u'type': u'boolean'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rs-discard-granularity',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/rs-discard-granularity",
                           u'max': 1048576,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': True,
                           u'drbd_option_name': u'disk-flushes',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-flushes",
                           u'type': u'boolean'},
                       {   u'default': 1237,
                           u'drbd_option_name': u'al-extents',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/al-extents",
                           u'max': 65534,
                           u'min': 67,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': True,
                           u'drbd_option_name': u'al-updates',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/al-updates",
                           u'type': u'boolean'},
                       {   u'default': True,
                           u'drbd_option_name': u'md-flushes',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/md-flushes",
                           u'type': u'boolean'},
                       {   u'default': False,
                           u'drbd_option_name': u'disk-barrier',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-barrier",
                           u'type': u'boolean'},
                       {   u'default': True,
                           u'drbd_option_name': u'discard-zeroes-if-aligned',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                           u'type': u'boolean'},
                       {   u'default': 100,
                           u'drbd_option_name': u'c-fill-target',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-fill-target",
                           u'max': 1048576,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u's'},
                       {   u'default': 102400,
                           u'drbd_option_name': u'c-max-rate',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-max-rate",
                           u'max': 4194304,
                           u'min': 250,
                           u'type': u'range',
                           u'unit': u'bytes/second',
                           u'unit_prefix': u'k'},
                       {   u'default': 250,
                           u'drbd_option_name': u'resync-rate',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/resync-rate",
                           u'max': 8388608,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'bytes/second',
                           u'unit_prefix': u'k'},
                       {   u'default': 10,
                           u'drbd_option_name': u'c-delay-target',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-delay-target",
                           u'max': 100,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 250,
                           u'drbd_option_name': u'c-min-rate',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-min-rate",
                           u'max': 4194304,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes/second',
                           u'unit_prefix': u'k'},
                       {   u'default': True,
                           u'drbd_option_name': u'bitmap',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/bitmap",
                           u'type': u'boolean'},
                       {   u'default': 20,
                           u'drbd_option_name': u'c-plan-ahead',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                           u'max': 300,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 100,
                           u'drbd_option_name': u'peer-ack-delay',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/peer-ack-delay",
                           u'max': 10000,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'milliseconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'quorum-minimum-redundancy',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/quorum-minimum-redundancy",
                           u'max': u'32',
                           u'min': u'1',
                           u'type': u'numeric-or-symbol',
                           u'values': [u'off', u'majority', u'all']},
                       {   u'default': 8000,
                           u'drbd_option_name': u'max-io-depth',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/max-io-depth",
                           u'max': 4294967295,
                           u'min': 4,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 20,
                           u'drbd_option_name': u'auto-promote-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/auto-promote-timeout",
                           u'max': 600,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'quorum',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/quorum",
                           u'max': u'32',
                           u'min': u'1',
                           u'type': u'numeric-or-symbol',
                           u'values': [u'off', u'majority', u'all']},
                       {   u'drbd_option_name': u'on-no-data-accessible',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/on-no-data-accessible",
                           u'type': u'symbol',
                           u'values': [u'io-error', u'suspend-io']},
                       {   u'default': True,
                           u'drbd_option_name': u'auto-promote',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/auto-promote",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'cpu-mask',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/cpu-mask",
                           u'type': u'string'},
                       {   u'default': 300,
                           u'drbd_option_name': u'twopc-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/twopc-timeout",
                           u'max': 600,
                           u'min': 50,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 1,
                           u'drbd_option_name': u'twopc-retry-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/twopc-retry-timeout",
                           u'max': 50,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 4096,
                           u'drbd_option_name': u'peer-ack-window',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/peer-ack-window",
                           u'max': 204800,
                           u'min': 2048,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u's'},
                       {   u'drbd_option_name': u'on-no-quorum',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/on-no-quorum",
                           u'type': u'symbol',
                           u'values': [u'io-error', u'suspend-io']},
                       {   u'default': 2048,
                           u'drbd_option_name': u'max-epoch-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/max-epoch-size",
                           u'max': 20000,
                           u'min': 1,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'protocol',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/protocol",
                           u'type': u'symbol',
                           u'values': [u'A', u'B', u'C']},
                       {   u'default': False,
                           u'drbd_option_name': u'allow-two-primaries',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/allow-two-primaries",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'after-sb-0pri',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/after-sb-0pri",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'discard-younger-primary',
                                          u'discard-older-primary',
                                          u'discard-zero-changes',
                                          u'discard-least-changes',
                                          u'discard-local',
                                          u'discard-remote']},
                       {   u'default': 7,
                           u'drbd_option_name': u'ko-count',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/ko-count",
                           u'max': 200,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'data-integrity-alg',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/data-integrity-alg",
                           u'type': u'string'},
                       {   u'default': 5,
                           u'drbd_option_name': u'ping-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/ping-timeout",
                           u'max': 300,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'sndbuf-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/sndbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'transport',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/transport",
                           u'type': u'string'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rcvbuf-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/rcvbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 2048,
                           u'drbd_option_name': u'max-buffers',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/max-buffers",
                           u'max': 131072,
                           u'min': 32,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'fencing',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/fencing",
                           u'type': u'symbol',
                           u'values': [   u'dont-care',
                                          u'resource-only',
                                          u'resource-and-stonith']},
                       {   u'drbd_option_name': u'csums-alg',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/csums-alg",
                           u'type': u'string'},
                       {   u'default': False,
                           u'drbd_option_name': u'always-asbp',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/always-asbp",
                           u'type': u'boolean'},
                       {   u'default': 1237,
                           u'drbd_option_name': u'congestion-extents',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/congestion-extents",
                           u'max': 65534,
                           u'min': 67,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'on-congestion',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/on-congestion",
                           u'type': u'symbol',
                           u'values': [   u'block',
                                          u'pull-ahead',
                                          u'disconnect']},
                       {   u'default': 10,
                           u'drbd_option_name': u'ping-int',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/ping-int",
                           u'max': 120,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'rr-conflict',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/rr-conflict",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'call-pri-lost',
                                          u'violently']},
                       {   u'default': True,
                           u'drbd_option_name': u'tcp-cork',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/tcp-cork",
                           u'type': u'boolean'},
                       {   u'default': True,
                           u'drbd_option_name': u'use-rle',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/use-rle",
                           u'type': u'boolean'},
                       {   u'default': False,
                           u'drbd_option_name': u'csums-after-crash-only',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/csums-after-crash-only",
                           u'type': u'boolean'},
                       {   u'default': 0,
                           u'drbd_option_name': u'socket-check-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/socket-check-timeout",
                           u'max': 300,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'congestion-fill',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/congestion-fill",
                           u'max': 20971520,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u's'},
                       {   u'drbd_option_name': u'cram-hmac-alg',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/cram-hmac-alg",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'verify-alg',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/verify-alg",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'shared-secret',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/shared-secret",
                           u'type': u'string'},
                       {   u'default': 10,
                           u'drbd_option_name': u'connect-int',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/connect-int",
                           u'max': 120,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 60,
                           u'drbd_option_name': u'timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/timeout",
                           u'max': 600,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'after-sb-2pri',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/after-sb-2pri",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'call-pri-lost-after-sb',
                                          u'violently-as0p']},
                       {   u'drbd_option_name': u'after-sb-1pri',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/after-sb-1pri",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'consensus',
                                          u'discard-secondary',
                                          u'call-pri-lost-after-sb',
                                          u'violently-as0p']},
                       {   u'drbd_option_name': u'after-resync-target',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/after-resync-target",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'before-resync-target',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/before-resync-target",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'before-resync-source',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/before-resync-source",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'out-of-sync',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/out-of-sync",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'quorum-lost',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/quorum-lost",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'fence-peer',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/fence-peer",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'unfence-peer',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/unfence-peer",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'initial-split-brain',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/initial-split-brain",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'local-io-error',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/local-io-error",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'pri-lost',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/pri-lost",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'pri-lost-after-sb',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/pri-lost-after-sb",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'pri-on-incon-degr',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/pri-on-incon-degr",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'split-brain',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/split-brain",
                           u'type': u'string'}],
    u'drbd-proxy': [   {   u'default': 16777216,
                           u'drbd_option_name': u'memlimit',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/memlimit",
                           u'max': 9223372036854775807,
                           u'min': 16777216,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'read-loops',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/read-loops",
                           u'max': 2147483647,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'sndbuf-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/sndbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rcvbuf-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/rcvbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 200,
                           u'drbd_option_name': u'ping-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/ping-timeout",
                           u'max': 300,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'}],
    u'drbd-proxy-lzma': [   {   u'default': 32768,
                                u'drbd_option_name': u'dict-size',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/dict-size",
                                u'max': 1610612736,
                                u'min': 4096,
                                u'type': u'range'},
                            {   u'default': 3,
                                u'drbd_option_name': u'lc',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/lc",
                                u'max': 4,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 0,
                                u'drbd_option_name': u'lp',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/lp",
                                u'max': 4,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 2,
                                u'drbd_option_name': u'pb',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/pb",
                                u'max': 4,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 273,
                                u'drbd_option_name': u'nice-len',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/nice-len",
                                u'max': 273,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': u'hc3',
                                u'drbd_option_name': u'mf',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/mf",
                                u'type': u'symbol',
                                u'values': [   u'hc4',
                                               u'hc3',
                                               u'bt2',
                                               u'bt3',
                                               u'bt4']},
                            {   u'default': u'fast',
                                u'drbd_option_name': u'mode',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/mode",
                                u'type': u'symbol',
                                u'values': [u'fast', u'normal']},
                            {   u'default': 0,
                                u'drbd_option_name': u'depth',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/depth",
                                u'max': 1000,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 4,
                                u'drbd_option_name': u'level',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/level",
                                u'max': 9,
                                u'min': 1,
                                u'type': u'range'},
                            {   u'default': u'thread count',
                                u'drbd_option_name': u'contexts',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/contexts",
                                u'max': 253,
                                u'min': 1,
                                u'type': u'range'},
                            {   u'default': u'off',
                                u'drbd_option_name': u'fallback-to-zlib',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/fallback-to-zlib",
                                u'type': u'symbol',
                                u'values': [u'off', u'on']},
                            {   u'default': 0,
                                u'drbd_option_name': u'numa-threshold',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/numa-threshold",
                                u'max': 253,
                                u'min': 0,
                                u'type': u'range'}],
    u'drbd-proxy-zlib': [   {   u'default': 2,
                                u'drbd_option_name': u'level',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/level",
                                u'max': 9,
                                u'min': 1,
                                u'type': u'range'}],
    u'node': [   {   u'info': u'Linstor storage pool name to use.',
                     u'key': consts.KEY_STOR_POOL_NAME,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_COMPOSED_NODE_NAME,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_STOR_SVC,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_USER_NAME,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_USER_PW,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_URL,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_RETRY_COUNT,
                     u'type': u'regex',
                     u'value': u'[0-9]+'},
                 {   u'internal': True,
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_RETRY_DELAY,
                     u'type': u'regex',
                     u'value': u'[0-9]+'}],
    u'resource': [   {   u'info': u'Linstor storage pool name to use.',
                         u'key': consts.KEY_STOR_POOL_NAME,
                         u'type': u'regex',
                         u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                     {   u'info': u'Preferred network interface to use',
                         u'key': consts.KEY_STOR_POOL_PREF_NIC,
                         u'type': u'regex',
                         u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                     {   u'info': u'DRBD peer slots present on resource',
                         u'internal': True,
                         u'key': consts.KEY_PEER_SLOTS,
                         u'max': 31,
                         u'min': 1,
                         u'type': u'range'},
                     {   u'info': u'File system type to use',
                         u'internal': True,
                         u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_TYPE,
                         u'type': u'symbol',
                         u'values': [u'ext4', u'xfs']},
                     {   u'info': u'Additional parameters for the mkfs command',
                         u'internal': False,
                         u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_MKFSPARAMETERS,
                         u'type': u'string'},
                     {   u'info': u'Preferred network interface to use',
                         u'internal': False,
                         u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PREF_NIC,
                         u'type': u'regex',
                         u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'}],
    u'resource-definition': [   {   u'info': u'Linstor storage pool name to use.',
                                    u'key': consts.KEY_STOR_POOL_NAME,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'info': u'DRBD peer slots to allocate for newly created resources (default 7), the number of peer slots cannot be changed once the resource is created, so allow sufficient slots to increase redundancy in the future',
                                    u'key': consts.KEY_PEER_SLOTS_NEW_RESOURCE,
                                    u'max': 31,
                                    u'min': 1,
                                    u'type': u'range'},
                                {   u'internal': True,
                                    u'key': consts.NAMESPC_DRBD_PROXY + '/' + consts.KEY_DRBD_PROXY_COMPRESSION_TYPE,
                                    u'type': u'symbol',
                                    u'values': [u'zlib', u'lzma', u'lz4']},
                                {   u'info': u'File system type to use',
                                    u'internal': True,
                                    u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_TYPE,
                                    u'type': u'symbol',
                                    u'values': [u'ext4', u'xfs']},
                                {   u'info': u'Additional parameters for the mkfs command',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_MKFSPARAMETERS,
                                    u'type': u'string'},
                                {   u'default': u'rdma',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_NVME + '/' + consts.KEY_TR_TYPE,
                                    u'type': u'symbol',
                                    u'values': [u'rdma', u'tcp']},
                                {   u'internal': False,
                                    u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PORT,
                                    u'max': 65535,
                                    u'min': 1,
                                    u'type': u'range'},
                                {   u'drbd_option_name': u'read-balancing',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/read-balancing",
                                    u'type': u'symbol',
                                    u'values': [   u'prefer-local',
                                                   u'prefer-remote',
                                                   u'round-robin',
                                                   u'least-pending',
                                                   u'when-congested-remote',
                                                   u'32K-striping',
                                                   u'64K-striping',
                                                   u'128K-striping',
                                                   u'256K-striping',
                                                   u'512K-striping',
                                                   u'1M-striping']},
                                {   u'drbd_option_name': u'on-io-error',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/on-io-error",
                                    u'type': u'symbol',
                                    u'values': [   u'pass_on',
                                                   u'call-local-io-error',
                                                   u'detach']},
                                {   u'default': True,
                                    u'drbd_option_name': u'disk-drain',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-drain",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'resync-after',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/resync-after",
                                    u'type': u'string'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'disk-timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-timeout",
                                    u'max': 6000,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': False,
                                    u'drbd_option_name': u'disable-write-same',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disable-write-same",
                                    u'type': u'boolean'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'rs-discard-granularity',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/rs-discard-granularity",
                                    u'max': 1048576,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u'1'},
                                {   u'default': True,
                                    u'drbd_option_name': u'disk-flushes',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-flushes",
                                    u'type': u'boolean'},
                                {   u'default': 1237,
                                    u'drbd_option_name': u'al-extents',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/al-extents",
                                    u'max': 65534,
                                    u'min': 67,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': True,
                                    u'drbd_option_name': u'al-updates',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/al-updates",
                                    u'type': u'boolean'},
                                {   u'default': True,
                                    u'drbd_option_name': u'md-flushes',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/md-flushes",
                                    u'type': u'boolean'},
                                {   u'default': False,
                                    u'drbd_option_name': u'disk-barrier',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-barrier",
                                    u'type': u'boolean'},
                                {   u'default': True,
                                    u'drbd_option_name': u'discard-zeroes-if-aligned',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                                    u'type': u'boolean'},
                                {   u'default': 100,
                                    u'drbd_option_name': u'c-fill-target',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-fill-target",
                                    u'max': 1048576,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u's'},
                                {   u'default': 102400,
                                    u'drbd_option_name': u'c-max-rate',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-max-rate",
                                    u'max': 4194304,
                                    u'min': 250,
                                    u'type': u'range',
                                    u'unit': u'bytes/second',
                                    u'unit_prefix': u'k'},
                                {   u'default': 250,
                                    u'drbd_option_name': u'resync-rate',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/resync-rate",
                                    u'max': 8388608,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'bytes/second',
                                    u'unit_prefix': u'k'},
                                {   u'default': 10,
                                    u'drbd_option_name': u'c-delay-target',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-delay-target",
                                    u'max': 100,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 250,
                                    u'drbd_option_name': u'c-min-rate',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-min-rate",
                                    u'max': 4194304,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes/second',
                                    u'unit_prefix': u'k'},
                                {   u'default': True,
                                    u'drbd_option_name': u'bitmap',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/bitmap",
                                    u'type': u'boolean'},
                                {   u'default': 20,
                                    u'drbd_option_name': u'c-plan-ahead',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                                    u'max': 300,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 100,
                                    u'drbd_option_name': u'peer-ack-delay',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/peer-ack-delay",
                                    u'max': 10000,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'milliseconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'quorum-minimum-redundancy',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/quorum-minimum-redundancy",
                                    u'max': u'32',
                                    u'min': u'1',
                                    u'type': u'numeric-or-symbol',
                                    u'values': [u'off', u'majority', u'all']},
                                {   u'default': 8000,
                                    u'drbd_option_name': u'max-io-depth',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/max-io-depth",
                                    u'max': 4294967295,
                                    u'min': 4,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': 20,
                                    u'drbd_option_name': u'auto-promote-timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/auto-promote-timeout",
                                    u'max': 600,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'quorum',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/quorum",
                                    u'max': u'32',
                                    u'min': u'1',
                                    u'type': u'numeric-or-symbol',
                                    u'values': [u'off', u'majority', u'all']},
                                {   u'drbd_option_name': u'on-no-data-accessible',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/on-no-data-accessible",
                                    u'type': u'symbol',
                                    u'values': [u'io-error', u'suspend-io']},
                                {   u'default': True,
                                    u'drbd_option_name': u'auto-promote',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/auto-promote",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'cpu-mask',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/cpu-mask",
                                    u'type': u'string'},
                                {   u'default': 300,
                                    u'drbd_option_name': u'twopc-timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/twopc-timeout",
                                    u'max': 600,
                                    u'min': 50,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 1,
                                    u'drbd_option_name': u'twopc-retry-timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/twopc-retry-timeout",
                                    u'max': 50,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 4096,
                                    u'drbd_option_name': u'peer-ack-window',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/peer-ack-window",
                                    u'max': 204800,
                                    u'min': 2048,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u's'},
                                {   u'drbd_option_name': u'on-no-quorum',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/on-no-quorum",
                                    u'type': u'symbol',
                                    u'values': [u'io-error', u'suspend-io']},
                                {   u'default': 2048,
                                    u'drbd_option_name': u'max-epoch-size',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/max-epoch-size",
                                    u'max': 20000,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'protocol',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/protocol",
                                    u'type': u'symbol',
                                    u'values': [u'A', u'B', u'C']},
                                {   u'default': False,
                                    u'drbd_option_name': u'allow-two-primaries',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/allow-two-primaries",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'after-sb-0pri',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/after-sb-0pri",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'discard-younger-primary',
                                                   u'discard-older-primary',
                                                   u'discard-zero-changes',
                                                   u'discard-least-changes',
                                                   u'discard-local',
                                                   u'discard-remote']},
                                {   u'default': 7,
                                    u'drbd_option_name': u'ko-count',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/ko-count",
                                    u'max': 200,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'data-integrity-alg',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/data-integrity-alg",
                                    u'type': u'string'},
                                {   u'default': 5,
                                    u'drbd_option_name': u'ping-timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/ping-timeout",
                                    u'max': 300,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'sndbuf-size',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/sndbuf-size",
                                    u'max': 10485760,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'transport',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/transport",
                                    u'type': u'string'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'rcvbuf-size',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/rcvbuf-size",
                                    u'max': 10485760,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u'1'},
                                {   u'default': 2048,
                                    u'drbd_option_name': u'max-buffers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/max-buffers",
                                    u'max': 131072,
                                    u'min': 32,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'fencing',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/fencing",
                                    u'type': u'symbol',
                                    u'values': [   u'dont-care',
                                                   u'resource-only',
                                                   u'resource-and-stonith']},
                                {   u'drbd_option_name': u'csums-alg',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/csums-alg",
                                    u'type': u'string'},
                                {   u'default': False,
                                    u'drbd_option_name': u'always-asbp',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/always-asbp",
                                    u'type': u'boolean'},
                                {   u'default': 1237,
                                    u'drbd_option_name': u'congestion-extents',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/congestion-extents",
                                    u'max': 65534,
                                    u'min': 67,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'on-congestion',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/on-congestion",
                                    u'type': u'symbol',
                                    u'values': [   u'block',
                                                   u'pull-ahead',
                                                   u'disconnect']},
                                {   u'default': 10,
                                    u'drbd_option_name': u'ping-int',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/ping-int",
                                    u'max': 120,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'rr-conflict',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/rr-conflict",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'call-pri-lost',
                                                   u'violently']},
                                {   u'default': True,
                                    u'drbd_option_name': u'tcp-cork',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/tcp-cork",
                                    u'type': u'boolean'},
                                {   u'default': True,
                                    u'drbd_option_name': u'use-rle',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/use-rle",
                                    u'type': u'boolean'},
                                {   u'default': False,
                                    u'drbd_option_name': u'csums-after-crash-only',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/csums-after-crash-only",
                                    u'type': u'boolean'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'socket-check-timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/socket-check-timeout",
                                    u'max': 300,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'congestion-fill',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/congestion-fill",
                                    u'max': 20971520,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u's'},
                                {   u'drbd_option_name': u'cram-hmac-alg',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/cram-hmac-alg",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'verify-alg',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/verify-alg",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'shared-secret',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/shared-secret",
                                    u'type': u'string'},
                                {   u'default': 10,
                                    u'drbd_option_name': u'connect-int',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/connect-int",
                                    u'max': 120,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 60,
                                    u'drbd_option_name': u'timeout',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/timeout",
                                    u'max': 600,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'after-sb-2pri',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/after-sb-2pri",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'call-pri-lost-after-sb',
                                                   u'violently-as0p']},
                                {   u'drbd_option_name': u'after-sb-1pri',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/after-sb-1pri",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'consensus',
                                                   u'discard-secondary',
                                                   u'call-pri-lost-after-sb',
                                                   u'violently-as0p']},
                                {   u'drbd_option_name': u'after-resync-target',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/after-resync-target",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'before-resync-target',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/before-resync-target",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'before-resync-source',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/before-resync-source",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'out-of-sync',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/out-of-sync",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'quorum-lost',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/quorum-lost",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'fence-peer',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/fence-peer",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'unfence-peer',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/unfence-peer",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'initial-split-brain',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/initial-split-brain",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'local-io-error',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/local-io-error",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'pri-lost',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/pri-lost",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'pri-lost-after-sb',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/pri-lost-after-sb",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'pri-on-incon-degr',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/pri-on-incon-degr",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'split-brain',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/split-brain",
                                    u'type': u'string'}],
    u'rsc-conn': [   {   u'default': 100,
                         u'drbd_option_name': u'c-fill-target',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-fill-target",
                         u'max': 1048576,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u's'},
                     {   u'default': 102400,
                         u'drbd_option_name': u'c-max-rate',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-max-rate",
                         u'max': 4194304,
                         u'min': 250,
                         u'type': u'range',
                         u'unit': u'bytes/second',
                         u'unit_prefix': u'k'},
                     {   u'default': 250,
                         u'drbd_option_name': u'resync-rate',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/resync-rate",
                         u'max': 8388608,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'bytes/second',
                         u'unit_prefix': u'k'},
                     {   u'default': 10,
                         u'drbd_option_name': u'c-delay-target',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-delay-target",
                         u'max': 100,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': 250,
                         u'drbd_option_name': u'c-min-rate',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-min-rate",
                         u'max': 4194304,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes/second',
                         u'unit_prefix': u'k'},
                     {   u'default': True,
                         u'drbd_option_name': u'bitmap',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/bitmap",
                         u'type': u'boolean'},
                     {   u'default': 20,
                         u'drbd_option_name': u'c-plan-ahead',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                         u'max': 300,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': 2048,
                         u'drbd_option_name': u'max-epoch-size',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/max-epoch-size",
                         u'max': 20000,
                         u'min': 1,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'protocol',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/protocol",
                         u'type': u'symbol',
                         u'values': [u'A', u'B', u'C']},
                     {   u'default': False,
                         u'drbd_option_name': u'allow-two-primaries',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/allow-two-primaries",
                         u'type': u'boolean'},
                     {   u'drbd_option_name': u'after-sb-0pri',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/after-sb-0pri",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'discard-younger-primary',
                                        u'discard-older-primary',
                                        u'discard-zero-changes',
                                        u'discard-least-changes',
                                        u'discard-local',
                                        u'discard-remote']},
                     {   u'default': 7,
                         u'drbd_option_name': u'ko-count',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/ko-count",
                         u'max': 200,
                         u'min': 0,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'data-integrity-alg',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/data-integrity-alg",
                         u'type': u'string'},
                     {   u'default': 5,
                         u'drbd_option_name': u'ping-timeout',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/ping-timeout",
                         u'max': 300,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': 0,
                         u'drbd_option_name': u'sndbuf-size',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/sndbuf-size",
                         u'max': 10485760,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'transport',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/transport",
                         u'type': u'string'},
                     {   u'default': 0,
                         u'drbd_option_name': u'rcvbuf-size',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/rcvbuf-size",
                         u'max': 10485760,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u'1'},
                     {   u'default': 2048,
                         u'drbd_option_name': u'max-buffers',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/max-buffers",
                         u'max': 131072,
                         u'min': 32,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'fencing',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/fencing",
                         u'type': u'symbol',
                         u'values': [   u'dont-care',
                                        u'resource-only',
                                        u'resource-and-stonith']},
                     {   u'drbd_option_name': u'csums-alg',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/csums-alg",
                         u'type': u'string'},
                     {   u'default': False,
                         u'drbd_option_name': u'always-asbp',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/always-asbp",
                         u'type': u'boolean'},
                     {   u'default': 1237,
                         u'drbd_option_name': u'congestion-extents',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/congestion-extents",
                         u'max': 65534,
                         u'min': 67,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'on-congestion',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/on-congestion",
                         u'type': u'symbol',
                         u'values': [u'block', u'pull-ahead', u'disconnect']},
                     {   u'default': 10,
                         u'drbd_option_name': u'ping-int',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/ping-int",
                         u'max': 120,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'seconds',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'rr-conflict',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/rr-conflict",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'call-pri-lost',
                                        u'violently']},
                     {   u'default': True,
                         u'drbd_option_name': u'tcp-cork',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/tcp-cork",
                         u'type': u'boolean'},
                     {   u'default': True,
                         u'drbd_option_name': u'use-rle',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/use-rle",
                         u'type': u'boolean'},
                     {   u'default': False,
                         u'drbd_option_name': u'csums-after-crash-only',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/csums-after-crash-only",
                         u'type': u'boolean'},
                     {   u'default': 0,
                         u'drbd_option_name': u'socket-check-timeout',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/socket-check-timeout",
                         u'max': 300,
                         u'min': 0,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'default': 0,
                         u'drbd_option_name': u'congestion-fill',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/congestion-fill",
                         u'max': 20971520,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u's'},
                     {   u'drbd_option_name': u'cram-hmac-alg',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/cram-hmac-alg",
                         u'type': u'string'},
                     {   u'drbd_option_name': u'verify-alg',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/verify-alg",
                         u'type': u'string'},
                     {   u'drbd_option_name': u'shared-secret',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/shared-secret",
                         u'type': u'string'},
                     {   u'default': 10,
                         u'drbd_option_name': u'connect-int',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/connect-int",
                         u'max': 120,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': 60,
                         u'drbd_option_name': u'timeout',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/timeout",
                         u'max': 600,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'after-sb-2pri',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/after-sb-2pri",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'call-pri-lost-after-sb',
                                        u'violently-as0p']},
                     {   u'drbd_option_name': u'after-sb-1pri',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/after-sb-1pri",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'consensus',
                                        u'discard-secondary',
                                        u'call-pri-lost-after-sb',
                                        u'violently-as0p']}],
    u'storagepool': [   {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_VOLUME_GROUP,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_THIN_POOL,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZPOOL,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_/-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZPOOLTHIN,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_/-]+'},
                        {   u'info': u'Preferred network interface to use',
                            u'key': consts.KEY_STOR_POOL_PREF_NIC,
                            u'type': u'regex',
                            u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_STOR_POOL,
                            u'type': u'regex',
                            u'value': u'.*'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_POLL_TIMEOUT_VLM_CRT,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_POLL_RETRIES_VLM_CRT,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_POLL_TIMEOUT_ATTACH_VLM,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_POLL_RETRIES_ATTACH_VLM,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_POLL_TIMEOUT_GREP_NVME_UUID,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_POLL_RETRIES_GREP_NVME_UUID,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_RETRY_COUNT,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_SF_RETRY_DELAY,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'default': u'linear',
                            u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_TYPE,
                            u'type': u'symbol',
                            u'values': [   u'linear',
                                           u'striped',
                                           u'mirror',
                                           u'raid0',
                                           u'raid1',
                                           u'raid4',
                                           u'raid5',
                                           u'raid6',
                                           u'raid10',
                                           u'lzma',
                                           u'lz4']},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_WAIT_TIMEOUT_AFTER_CREATE,
                            u'type': u'regex',
                            u'value': u'[0-9]+'}],
    u'storagepool-definition': [   {   u'info': u'Maximum allowed ratio of the sum of volume sizes in a thin pool to the total capacity of the pool (default 20)',
                                       u'key': consts.KEY_STOR_POOL_DFN_MAX_OVERSUBSCRIPTION_RATIO,
                                       u'max': 1000,
                                       u'min': 1,
                                       u'type': u'range'}],
    u'volume-definition': [   {   u'info': u'Linstor storage pool name to use.',
                                  u'key': consts.KEY_STOR_POOL_NAME,
                                  u'type': u'regex',
                                  u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'info': u"Overwrites the generated '<resource-name>_<5 digit volume number>' volume name for migration purposes",
                                  u'key': consts.KEY_STOR_POOL_OVERRIDE_VLM_ID,
                                  u'type': u'regex',
                                  u'value': u'.*'},
                              {   u'info': u'Do not fail when the underlying volume is larger than expected',
                                  u'key': consts.KEY_ALLOW_LARGER_VOLUME_SIZE,
                                  u'type': u'boolean_true_false'},
                              {   u'info': u'File system type to use',
                                  u'internal': True,
                                  u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_TYPE,
                                  u'type': u'symbol',
                                  u'values': [u'ext4', u'xfs']},
                              {   u'info': u'Additional parameters for the mkfs command',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_MKFSPARAMETERS,
                                  u'type': u'string'},
                              {   u'default': u'linear',
                                  u'internal': True,
                                  u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_TYPE,
                                  u'type': u'symbol',
                                  u'values': [   u'linear',
                                                 u'striped',
                                                 u'mirror',
                                                 u'raid0',
                                                 u'raid1',
                                                 u'raid4',
                                                 u'raid5',
                                                 u'raid6',
                                                 u'raid10',
                                                 u'lzma',
                                                 u'lz4']},
                              {   u'internal': False,
                                  u'key': consts.KEY_DRBD_CURRENT_GI,
                                  u'type': u'regex',
                                  u'value': u'[a-fA-F0-9]{16}'},
                              {   u'drbd_option_name': u'read-balancing',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/read-balancing",
                                  u'type': u'symbol',
                                  u'values': [   u'prefer-local',
                                                 u'prefer-remote',
                                                 u'round-robin',
                                                 u'least-pending',
                                                 u'when-congested-remote',
                                                 u'32K-striping',
                                                 u'64K-striping',
                                                 u'128K-striping',
                                                 u'256K-striping',
                                                 u'512K-striping',
                                                 u'1M-striping']},
                              {   u'drbd_option_name': u'on-io-error',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/on-io-error",
                                  u'type': u'symbol',
                                  u'values': [   u'pass_on',
                                                 u'call-local-io-error',
                                                 u'detach']},
                              {   u'default': True,
                                  u'drbd_option_name': u'disk-drain',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-drain",
                                  u'type': u'boolean'},
                              {   u'drbd_option_name': u'resync-after',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/resync-after",
                                  u'type': u'string'},
                              {   u'default': 0,
                                  u'drbd_option_name': u'disk-timeout',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-timeout",
                                  u'max': 6000,
                                  u'min': 0,
                                  u'type': u'range',
                                  u'unit': u'1/10 seconds',
                                  u'unit_prefix': u'1'},
                              {   u'default': False,
                                  u'drbd_option_name': u'disable-write-same',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disable-write-same",
                                  u'type': u'boolean'},
                              {   u'default': 0,
                                  u'drbd_option_name': u'rs-discard-granularity',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/rs-discard-granularity",
                                  u'max': 1048576,
                                  u'min': 0,
                                  u'type': u'range',
                                  u'unit': u'bytes',
                                  u'unit_prefix': u'1'},
                              {   u'default': True,
                                  u'drbd_option_name': u'disk-flushes',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-flushes",
                                  u'type': u'boolean'},
                              {   u'default': 1237,
                                  u'drbd_option_name': u'al-extents',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/al-extents",
                                  u'max': 65534,
                                  u'min': 67,
                                  u'type': u'range',
                                  u'unit_prefix': u'1'},
                              {   u'default': True,
                                  u'drbd_option_name': u'al-updates',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/al-updates",
                                  u'type': u'boolean'},
                              {   u'default': True,
                                  u'drbd_option_name': u'md-flushes',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/md-flushes",
                                  u'type': u'boolean'},
                              {   u'default': False,
                                  u'drbd_option_name': u'disk-barrier',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-barrier",
                                  u'type': u'boolean'},
                              {   u'default': True,
                                  u'drbd_option_name': u'discard-zeroes-if-aligned',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                                  u'type': u'boolean'}]}
